#include "libfspp.hpp"

#include "gettext.hpp"
#include "global_options.hpp"
#include "common.hpp"
#include "print.hpp"

bool sort_order(const std::string& lhs, const std::string& rhs, bool lhs_is_dir, bool rhs_is_dir, bool folders_first)
{
  if (!folders_first)
    return (lhs <= rhs);
  else if (folders_first) {
    if ((lhs_is_dir && !rhs_is_dir) || (!lhs_is_dir && rhs_is_dir))
      return (lhs_is_dir >= rhs_is_dir);
    else
      return (lhs <= rhs);
  } else {
    print_critical(gettext("Unknown sorting order"), "LIBFS++");
    return false;
  }
}
