#ifndef LYRICS_HPP
#define LYRICS_HPP

#include "module.hpp"
#include "singleton.hpp"

#include <string>
#include <vector>

class Lyrics : public Module
{
private:
  int idle_status();
  void check_status();

  //void calculate();

  bool search_result();
  bool get_text(const std::string& ret);
  bool parse_text (const std::string& text, const std::string& nsec = "\xD");

  std::string cache_artist;
  std::string cache_title;

  std::string lyrics_dir;
  std::string tmp_location;

  void Save();
  bool Load();

  std::string filename();

  bool enabled;

public:

  static pthread_mutex_t singleton_mutex;

  // Constructor adds itself to the updater loop
  Lyrics();

  std::vector<std::string> vecLyric;

  std::string buff_text;
  int count;
  int period;

  bool find_lyric(std::string artist, std::string title);
  std::string mainloop();

  bool get_status();
  bool is_enabled();

  void clear();

  Options* get_opts()
  {
    return 0;
  }

  void startup_updater()
  {}
};

typedef Singleton<Lyrics> S_Lyrics;

#endif
