#ifndef GUIWINDOWMANAGER_HPP
#define GUIWINDOWMANAGER_HPP

#include <cc++/thread.h>
#include "singleton.hpp"
#include "renderer.hpp"
#include "guiwindow.hpp"
#include "guimessage.hpp"
#include <vector>

namespace pymms {

namespace gui {

class GUIWindowManager
{
  private:
    std::vector<GUIWindow*> m_vecWindows;
    Overlay m_windowOverlay;
  
  public:

    static pthread_mutex_t singleton_mutex;

    GUIWindowManager();
    bool onAction(const std::string& strAction);
    void registerWindow(GUIWindow* pWindow);
    void unregisterWindow(GUIWindow* pWindow);
    void setActiveWindow(GUIWindow* pWindow);
    void setActiveWindow(int iWindowId);
    GUIWindow* getActiveWindow();
    GUIWindow* getWindow(int iWindowId);
    void render();
    void sendMessage(GUIMessage& message);
};

typedef Singleton<GUIWindowManager> S_WindowManager;

}

}

#endif
