#include "wget_wrapper.hpp"

#include "config.hpp"
#include "common-feature.hpp"

#include <fstream>
#include <iostream>

using std::string;

bool WgetWrapper::download(const std::string& url, std::string& contents)
{
  Config *conf = S_Config::get_instance();
  string tmp_location = conf->p_temp_image_loc() + "/wget-temp";

#ifdef __UCLIBC__
  run::external_program(("wget '" + url + "' -O " + tmp_location).c_str());
#else
  run::external_program(("wget -nv '" + url + "' -O " + tmp_location).c_str());
#endif

  std::ifstream in;
  in.open(tmp_location.c_str(), std::ios::in);

  if (!in.is_open()) {
    return false;
  } else {

    string str;

    while (getline(in, str))
      contents += str + "\n";

    in.close();

    // fixme escape?
    run::external_program(("rm " + tmp_location).c_str());

    return true;
  }
}

void WgetWrapper::download_to_file(const std::string& url, const std::string& file)
{
#ifdef __UCLIBC__
  run::external_program(("wget '" + url + "' -O " + string_format::escape_string(file)).c_str());
#else
  run::external_program(("wget -nv '" + url + "' -O " + string_format::escape_string(file)).c_str());
#endif
}

